'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _onecolor = require('../utils/onecolor');

var _onecolor2 = _interopRequireDefault(_onecolor);

var _editorCanvas = require('./editor-canvas.html');

var _editorCanvas2 = _interopRequireDefault(_editorCanvas);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    template: _editorCanvas2.default,
    props: ['options', 'global', 'layouts', 'currentLayout'],

    computed: {
        editor: function editor() {
            return this.$parent;
        },
        canvasBackgroundColor: function canvasBackgroundColor() {
            var color = this.global.backgroundColor;
            return color ? _onecolor2.default.rgbaParser(color).cssa() : '';
        },
        layoutBackgroundColor: function layoutBackgroundColor() {
            var color = this.currentLayout.backgroundColor;
            return color ? _onecolor2.default.rgbaParser(color).cssa() : 'transparent';
        }
    }
};
module.exports = exports['default'];