'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _onecolor = require('../utils/onecolor');

var _onecolor2 = _interopRequireDefault(_onecolor);

var _editorFlow = require('./editor-flow.html');

var _editorFlow2 = _interopRequireDefault(_editorFlow);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    template: _editorFlow2.default,
    props: ['options', 'global', 'layouts', 'currentLayout'],

    computed: {
        canvasBackgroundColor: function canvasBackgroundColor() {
            var color = this.global.backgroundColor;
            return color ? _onecolor2.default.rgbaParser(color).cssa() : '';
        },
        editor: function editor() {
            return this.$parent;
        }
    },

    methods: {
        setLayoutTop: function setLayoutTop() {
            this.layouts.reduce(function (prev, next) {
                next.top = prev;
                return prev + next.height;
            }, 0);
        }
    },

    watch: {
        'editor.height': function editorHeight() {
            this.setLayoutTop();
        },
        'layouts': function layouts() {
            this.setLayoutTop();
        }
    },

    created: function created() {
        this.setLayoutTop();
    },
    beforeDestroy: function beforeDestroy() {
        this.layouts.forEach(function (layout) {
            layout.top = 0;
        });
    }
};
module.exports = exports['default'];