'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {
  version: '5.6.0-beta.3',
  options: {
    mode: 'design',

    padding: 40,

    canvasOverflowHidden: true,
    autoFitZoom: true,
    showToolbar: true,
    showEditConfirmToolbar: true,
    showGuider: true,

    selector: true,

    elementLoadTimeout: 15 * 1000,

    clipboard: {
      get: function get() {},
      set: function set() {}
    },

    snapshotScope: 'layout',

    placeImage: 'https://cdn.dancf.com/assets/place.png',
    hookImagePicker: false,

    maskPixelRatio: 1,
    maskResizeOptions: {
      alpha: true
    },

    crossLayoutDrag: false,

    fitCrossOrigin: false,

    bindHotkey: null,

    cropperOptions: {
      switchable: false,

      defaultTarget: 'inner',

      outerResize: 0
    },

    fontList: [{ name: 'Microsoft Yahei', alias: '微软雅黑' }, { name: 'Simsun', alias: '宋体' }],
    fontSizeList: [6, 8, 9, 10, 11, 12, 14, 18, 24, 30, 36, 48, 60, 72, 84, 96, 108, 120],
    fontLoadTimeout: 10000
  },
  global: {
    zoom: 1
  },
  globalExts: {
    $draging: false,
    $rendered: false,
    $loaded: false
  },

  layout: {
    title: '',
    backgroundSize: null,
    backgroundImage: null,
    backgroundColor: '#FFFFFF',
    backgroundRepeat: 'no-repeat',
    height: 480,
    width: 640,

    className: null,

    repeatId: null,
    repeatGroup: null,

    $loaded: false,
    $dragOver: false
  },

  element: {
    type: '',

    category: '',

    opacity: 1,

    padding: [0, 0, 0, 0],
    width: 200,

    height: 200,

    left: 0,

    top: 0,

    transform: { a: 1, b: 0, c: 0, d: 1, tx: 0, ty: 0 },

    boxShadow: null,

    resize: 7,

    dragable: true,

    rotatable: true,

    editable: true,

    frozen: false,

    hidden: false,

    lock: false,

    borderRadius: 0,

    filter: {
      hueRotate: 0,
      saturate: 0,
      brightness: 0,
      gaussianBlur: 0
    }
  },

  elementExts: {
    $id: 0,
    $loaded: false,
    $selected: false,
    $editing: false,
    $draging: false,
    $blinking: false,

    $guider: { show: true, snapTo: true },

    $getDragLimit: null,
    $getResizeLimit: null,
    $dragLimit: false,
    $resizeLimit: false
  },

  imageElement: {
    url: '',

    originWidth: 0,

    originHeight: 0,

    effectedImage: '',

    effectedImageWidth: 0,

    effectedImageHeight: 0,

    effectedImageOffsetLeft: 0,

    effectedImageOffsetTop: 0,

    imageEffects: [],

    imageEffectsHash: '',

    aggregatedColors: [],

    mainColor: null,

    effectScale: 1
  },

  imageEffect: {
    enable: true,
    collapse: false,

    excludeScale: [],

    offset: {
      enable: true,
      x: 0,
      y: 0
    },

    stroke: {
      enable: false,
      color: '#000000',
      width: 0
    },

    shadow: {
      enable: false,
      color: '#000000',
      offsetX: 0,
      offsetY: 0,
      blur: 0
    },

    expand: {
      enable: false,
      offset: {
        left: 0,
        top: 0,
        right: 0,
        bottom: 0
      },
      scale: 1
    },

    filling: {
      enable: false,

      type: 'color',
      color: '#000000',
      imageContent: {
        repeat: 'no-repeat',

        scaleX: 1,
        scaleY: 1,

        image: null,
        width: null,
        height: null
      },

      gradient: {
        byLine: 0,

        angle: 0,
        stops: [{ color: '#FFFFFF', offset: 0 }, { color: '#000000', offset: 1 }],

        type: 'linear'
      }
    },

    mask: {
      type: 'circle',
      enable: false,
      image: null,
      height: null,
      width: null,

      radius: 0,

      repeat: 'no-repeat'
    },

    resize: 1
  },

  textElement: {
    color: '#000000',

    backgroundColor: null,

    padding: [0, 0, 0, 0],

    fontFamily: 'Simsun',

    fontStyle: 'normal',

    fontWeight: 400,

    fontSize: 20,

    lineHeight: 1.2,

    letterSpacing: 0,

    textDecoration: 'none',

    writingMode: 'horizontal-tb',
    textAlign: 'left',

    verticalAlign: 'top',

    contents: [],

    effectScale: 1,

    textShadow: null,

    resize: 5,

    autoScale: false,

    textEffects: [],

    aggregatedColors: [],

    mainColor: null
  },

  textEffect: {
    enable: true,
    collapse: false,

    excludeScale: [],

    offset: {
      enable: false,
      x: 0,
      y: 0
    },

    skew: {
      enable: false,
      x: 0,
      y: 0
    },

    stroke: {
      enable: false,
      color: '#000000',
      width: 0
    },

    shadow: {
      enable: false,
      color: '#000000',
      offsetX: 0,
      offsetY: 0,
      blur: 0
    },

    filling: {
      enable: false,

      type: 0,
      color: '#000000',
      imageContent: {
        repeat: 0,

        scaleX: 1,
        scaleY: 1,

        image: null,
        width: null,
        height: null
      },

      gradient: {
        byLine: 0,

        angle: 0,
        stops: [{ color: '#FFFFFF', offset: 0 }, { color: '#000000', offset: 1 }]
      }
    }
  },

  svgElement: {
    url: '',

    content: '',

    colors: null,

    resize: 7,

    containerTransform: null
  },

  maskElement: {
    image: null,

    resize: 1,

    clip: {
      bottom: 0,
      right: 0,
      left: 0,
      top: 0
    },

    url: '',

    mask: '',

    imageUrl: '',

    imageTransform: { a: 1, b: 0, c: 0, d: 1, tx: 0, ty: 0 },

    imageWidth: 0,

    imageHeight: 0
  },

  groupElement: {
    elements: [],

    autoGrow: false,

    canCollapse: true,

    resize: 1
  }
};
module.exports = exports['default'];