'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _editor = require('./editor');

var _editor2 = _interopRequireDefault(_editor);

var _editorDefaults = require('./editor-defaults');

var _editorDefaults2 = _interopRequireDefault(_editorDefaults);

var _editor3 = require('./base/editor.events');

var _editor4 = _interopRequireDefault(_editor3);

var _editorCanvas = require('./canvas/editor-canvas');

var _editorCanvas2 = _interopRequireDefault(_editorCanvas);

var _editorMirror = require('./canvas/editor-mirror');

var _editorMirror2 = _interopRequireDefault(_editorMirror);

var _editorFlow = require('./canvas/editor-flow');

var _editorFlow2 = _interopRequireDefault(_editorFlow);

var _editorLayout = require('./canvas/editor-layout');

var _editorLayout2 = _interopRequireDefault(_editorLayout);

var _editorElementImage = require('./canvas/editor-element-image');

var _editorElementImage2 = _interopRequireDefault(_editorElementImage);

var _editorElementText = require('./canvas/editor-element-text');

var _editorElementText2 = _interopRequireDefault(_editorElementText);

var _editorElementMask = require('./canvas/editor-element-mask');

var _editorElementMask2 = _interopRequireDefault(_editorElementMask);

var _editorElementSvg = require('./canvas/editor-element-svg');

var _editorElementSvg2 = _interopRequireDefault(_editorElementSvg);

var _editorElementGroup = require('./canvas/editor-element-group');

var _editorElementGroup2 = _interopRequireDefault(_editorElementGroup);

var _editorGuider = require('./components/editor-guider');

var _editorGuider2 = _interopRequireDefault(_editorGuider);

var _editorSelector = require('./components/editor-selector');

var _editorSelector2 = _interopRequireDefault(_editorSelector);

var _editorTransform = require('./components/editor-transform');

var _editorTransform2 = _interopRequireDefault(_editorTransform);

var _editorImageCroper = require('./components/editor-image-croper');

var _editorImageCroper2 = _interopRequireDefault(_editorImageCroper);

var _editorTextEditor = require('./components/editor-text-editor');

var _editorTextEditor2 = _interopRequireDefault(_editorTextEditor);

var _editorMaskEditor = require('./components/editor-mask-editor');

var _editorMaskEditor2 = _interopRequireDefault(_editorMaskEditor);

var _editorContextmenu = require('./components/editor-contextmenu');

var _editorContextmenu2 = _interopRequireDefault(_editorContextmenu);

var _editorLayerList = require('./components/editor-layer-list');

var _editorLayerList2 = _interopRequireDefault(_editorLayerList);

var _editorHighlightElement = require('./components/editor-highlight-element');

var _editorHighlightElement2 = _interopRequireDefault(_editorHighlightElement);

var _editorToolbarPop = require('./toolbar/editor-toolbar-pop');

var _editorToolbarPop2 = _interopRequireDefault(_editorToolbarPop);

var _editorToolbarMore = require('./toolbar/editor-toolbar-more');

var _editorToolbarMore2 = _interopRequireDefault(_editorToolbarMore);

var _editorToolbarSelector = require('./toolbar/editor-toolbar-selector');

var _editorToolbarSelector2 = _interopRequireDefault(_editorToolbarSelector);

var _editorToolbarMasker = require('./toolbar/editor-toolbar-masker');

var _editorToolbarMasker2 = _interopRequireDefault(_editorToolbarMasker);

var _editorToolbarCroper = require('./toolbar/editor-toolbar-croper');

var _editorToolbarCroper2 = _interopRequireDefault(_editorToolbarCroper);

var _editorToolbarGroup = require('./toolbar/editor-toolbar-group');

var _editorToolbarGroup2 = _interopRequireDefault(_editorToolbarGroup);

var _editorToolbarImage = require('./toolbar/editor-toolbar-image');

var _editorToolbarImage2 = _interopRequireDefault(_editorToolbarImage);

var _editorToolbarMask = require('./toolbar/editor-toolbar-mask');

var _editorToolbarMask2 = _interopRequireDefault(_editorToolbarMask);

var _editorToolbarText = require('./toolbar/editor-toolbar-text');

var _editorToolbarText2 = _interopRequireDefault(_editorToolbarText);

var _editorToolbarSvg = require('./toolbar/editor-toolbar-svg');

var _editorToolbarSvg2 = _interopRequireDefault(_editorToolbarSvg);

var _editorColorPicker = require('./widgets/editor-color-picker');

var _editorColorPicker2 = _interopRequireDefault(_editorColorPicker);

var _editorColorHue = require('./widgets/editor-color-hue');

var _editorColorHue2 = _interopRequireDefault(_editorColorHue);

var _editorColorBlock = require('./widgets/editor-color-block');

var _editorColorBlock2 = _interopRequireDefault(_editorColorBlock);

var _editorColorHistory = require('./widgets/editor-color-history');

var _editorColorHistory2 = _interopRequireDefault(_editorColorHistory);

var _editorComboPicker = require('./widgets/editor-combo-picker');

var _editorComboPicker2 = _interopRequireDefault(_editorComboPicker);

var _editorFilePicker = require('./widgets/editor-file-picker');

var _editorFilePicker2 = _interopRequireDefault(_editorFilePicker);

var _editorFileReader = require('./widgets/editor-file-reader');

var _editorFileReader2 = _interopRequireDefault(_editorFileReader);

var _editorImagePicker = require('./widgets/editor-image-picker');

var _editorImagePicker2 = _interopRequireDefault(_editorImagePicker);

var _editorNumberPicker = require('./widgets/editor-number-picker');

var _editorNumberPicker2 = _interopRequireDefault(_editorNumberPicker);

var _editorOpacityPicker = require('./widgets/editor-opacity-picker');

var _editorOpacityPicker2 = _interopRequireDefault(_editorOpacityPicker);

var _editorPercentageScaler = require('./widgets/editor-percentage-scaler');

var _editorPercentageScaler2 = _interopRequireDefault(_editorPercentageScaler);

var _editorRangePicker = require('./widgets/editor-range-picker');

var _editorRangePicker2 = _interopRequireDefault(_editorRangePicker);

var _editorSelectPicker = require('./widgets/editor-select-picker');

var _editorSelectPicker2 = _interopRequireDefault(_editorSelectPicker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var components = {
    'editor': _editor2.default,

    'editor-canvas': _editorCanvas2.default,
    'editor-mirror': _editorMirror2.default,
    'editor-flow': _editorFlow2.default,
    'editor-layout': _editorLayout2.default,

    'editor-element-image': _editorElementImage2.default,
    'editor-element-text': _editorElementText2.default,
    'editor-element-mask': _editorElementMask2.default,
    'editor-element-svg': _editorElementSvg2.default,
    'editor-element-group': _editorElementGroup2.default,

    'editor-guider': _editorGuider2.default,
    'editor-selector': _editorSelector2.default,
    'editor-transform': _editorTransform2.default,
    'editor-image-croper': _editorImageCroper2.default,
    'editor-text-editor': _editorTextEditor2.default,
    'editor-mask-editor': _editorMaskEditor2.default,
    'editor-contextmenu': _editorContextmenu2.default,
    'editor-layer-list': _editorLayerList2.default,
    'editor-highlight-element': _editorHighlightElement2.default,

    'editor-toolbar-pop': _editorToolbarPop2.default,
    'editor-toolbar-more': _editorToolbarMore2.default,
    'editor-toolbar-selector': _editorToolbarSelector2.default,
    'editor-toolbar-masker': _editorToolbarMasker2.default,
    'editor-toolbar-croper': _editorToolbarCroper2.default,
    'editor-toolbar-group': _editorToolbarGroup2.default,
    'editor-toolbar-image': _editorToolbarImage2.default,
    'editor-toolbar-mask': _editorToolbarMask2.default,
    'editor-toolbar-text': _editorToolbarText2.default,
    'editor-toolbar-svg': _editorToolbarSvg2.default,

    'editor-color-picker': _editorColorPicker2.default,
    'editor-color-hue': _editorColorHue2.default,
    'editor-color-block': _editorColorBlock2.default,
    'editor-color-history': _editorColorHistory2.default,
    'editor-combo-picker': _editorComboPicker2.default,
    'editor-file-picker': _editorFilePicker2.default,
    'editor-file-reader': _editorFileReader2.default,
    'editor-image-picker': _editorImagePicker2.default,
    'editor-number-picker': _editorNumberPicker2.default,
    'editor-opacity-picker': _editorOpacityPicker2.default,
    'editor-percentage-scaler': _editorPercentageScaler2.default,
    'editor-range-picker': _editorRangePicker2.default,
    'editor-select-picker': _editorSelectPicker2.default
};

VuePosterEditor.defaultConfig = _editorDefaults2.default;

function VuePosterEditor(Vue) {
    Object.keys(components).forEach(function (name) {
        var BaseComponent = Vue.extend(_editor4.default);
        var Component = buildComponent(BaseComponent, components[name]);

        Vue.component(name, Component);
    });
}

function buildComponent(BaseComponent, configs) {
    if (!Array.isArray(configs)) {
        configs = [configs];
    }

    var Component = BaseComponent;
    var allEvent = {};

    configs.forEach(function (config) {
        var events = config.events;
        for (var key in events) {
            if (!allEvent[key]) {
                allEvent[key] = [];
            }
            allEvent[key].push(events[key]);
        }

        Component = Component.extend(config);
    });

    Component = Component.extend({
        created: function created() {
            var _this = this;

            var eventStore = this.$eventStore = {};
            var events = this.$events;

            if (!events) {
                return;
            }

            var _loop = function _loop(key) {
                _this.$eventStore[key] = [];

                allEvent[key].forEach(function (event) {
                    var handler = event.bind(_this);

                    eventStore[key].push(handler);
                    events.$on(key, handler);
                });
            };

            for (var key in allEvent) {
                _loop(key);
            }
        },
        beforeDestroy: function beforeDestroy() {
            var eventStore = this.$eventStore;
            var events = this.$events;

            if (!events) {
                return;
            }

            var _loop2 = function _loop2(key) {
                eventStore[key].forEach(function (event) {
                    events.$off(key, event);
                });
            };

            for (var key in eventStore) {
                _loop2(key);
            }
        }
    });

    return Component;
}

if (typeof Vue !== 'undefined') {
    Vue.use(VuePosterEditor);
}

VuePosterEditor.components = components;

exports.default = VuePosterEditor;
module.exports = exports['default'];