'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _utils = require('../utils/utils');

var _elementUseModel = require('../utils/element-use-model');

var _elementBaseModel = require('./element-base-model');

var _elementBaseModel2 = _interopRequireDefault(_elementBaseModel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ElementGroupModel = function (_ElementBaseModel) {
    _inherits(ElementGroupModel, _ElementBaseModel);

    function ElementGroupModel(data) {
        _classCallCheck(this, ElementGroupModel);

        var modelVersion = _utils.version.parse(data.version || '0.0.0');

        if (modelVersion.major < 2) {
            data.elements = data.elements || data.elems;
            delete data.elems;
        }

        var _this = _possibleConstructorReturn(this, (ElementGroupModel.__proto__ || Object.getPrototypeOf(ElementGroupModel)).call(this, data));

        if (_this.elements.length) {
            _this.elements = _this.elements.map(function (element) {
                element = (0, _elementUseModel.useElementModel)(element);
                element.disableEditable();
                return element;
            });
        }
        return _this;
    }

    return ElementGroupModel;
}(_elementBaseModel2.default);

exports.default = ElementGroupModel;
module.exports = exports['default'];