'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _forEach2 = require('lodash/forEach');

var _forEach3 = _interopRequireDefault(_forEach2);

var _utils = require('../utils/utils');

var _elementModel = require('../utils/element-model');

var _elementBaseModel = require('./element-base-model');

var _elementBaseModel2 = _interopRequireDefault(_elementBaseModel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ElementSvgModel = function (_ElementBaseModel) {
    _inherits(ElementSvgModel, _ElementBaseModel);

    function ElementSvgModel(data) {
        _classCallCheck(this, ElementSvgModel);

        var modelVersion = _utils.version.parse(data.version || '0.0.0');

        if (modelVersion.major < 2) {
            var colors = data.colors;
            (0, _forEach3.default)(data.colors || [], function (value, key) {
                colors[key] = (0, _elementModel.hexaToRgba)(value);
            });
        }

        var _this = _possibleConstructorReturn(this, (ElementSvgModel.__proto__ || Object.getPrototypeOf(ElementSvgModel)).call(this, data));

        if (_this.colors) {
            (0, _forEach3.default)(_this.colors, function (color, key) {
                _this.colors[key] = (0, _elementModel.hexaToRgba)(color);
            });
        }
        return _this;
    }

    return ElementSvgModel;
}(_elementBaseModel2.default);

exports.default = ElementSvgModel;
module.exports = exports['default'];