'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _editorThumbnailImage = require('./editor-thumbnail-image.html');

var _editorThumbnailImage2 = _interopRequireDefault(_editorThumbnailImage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

;

exports.default = {

    template: _editorThumbnailImage2.default,

    props: ['element'],

    data: function data() {
        return {};
    },

    computed: {
        ratio: function ratio() {
            return Math.max(this.element.width / 43, this.element.height / 43);
        },


        transform: function transform() {
            return this.element.transform;
        },

        clip: function clip() {
            return this.element.clip || { top: 0, left: 0, right: 0, bottom: 0 };
        },
        width: function width() {
            return this.element.width / this.ratio;
        },
        height: function height() {
            return this.element.height / this.ratio;
        },
        outerSize: function outerSize() {
            var clip = this.clip;
            return {
                width: this.width + (clip.left + clip.right) / this.ratio,
                height: this.height + (clip.top + clip.bottom) / this.ratio
            };
        },
        category: function category() {
            var category = this.element.category;

            if ((typeof category === 'undefined' ? 'undefined' : _typeof(category)) === 'object') {
                return category.name ? '[' + category.name + '] ' : '';
            }
            return category ? '[' + category + '] ' : '';
        },
        title: function title() {
            return this.category + '图片';
        }
    }
};
module.exports = exports['default'];