'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _editorThumbnailMask = require('./editor-thumbnail-mask.html');

var _editorThumbnailMask2 = _interopRequireDefault(_editorThumbnailMask);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

;

exports.default = {

    template: _editorThumbnailMask2.default,

    props: ['element'],

    data: function data() {
        return {};
    },


    computed: {
        ratio: function ratio() {
            return Math.max(this.element.width / 43, this.element.height / 43);
        },
        transform: function transform() {
            return this.element.transform;
        },
        width: function width() {
            return this.element.width / this.ratio;
        },
        height: function height() {
            return this.element.height / this.ratio;
        },
        category: function category() {
            var category = this.element.category;

            if ((typeof category === 'undefined' ? 'undefined' : _typeof(category)) === 'object') {
                return category.name ? '[' + category.name + '] ' : '';
            }
            return category ? '[' + category + '] ' : '';
        },
        title: function title() {
            return this.category + '蒙版图片';
        }
    }
};
module.exports = exports['default'];