'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _editorThumbnailSvg = require('./editor-thumbnail-svg.html');

var _editorThumbnailSvg2 = _interopRequireDefault(_editorThumbnailSvg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {

    template: _editorThumbnailSvg2.default,

    props: ['element'],

    data: function data() {
        return {};
    },


    computed: {
        colors: function colors() {
            return this.element.colors;
        },
        svg: function svg() {
            var _this = this;

            var category = this.element.category;
            if (category && category.type === 'table') {
                return "<span style='font-size: 56px; line-height:38px;'>⊞</span>";
            }

            var content = this.element.$content;

            content = content.replace(/colors\[&quot;(.*?)&quot;]/g, 'colors[\'$1\']');
            content = content.replace(/:(fill|strock-color)="colors(.*?)"/g, function (all, attr, key) {
                var keyStr = key.replace(/[.\[\]']/g, '');

                return attr + '="' + _this.colors[keyStr] + '"';
            });

            return content;
        },
        category: function category() {
            var category = this.element.category;

            if ((typeof category === 'undefined' ? 'undefined' : _typeof(category)) === 'object') {
                return category.name ? '[' + category.name + '] ' : '';
            }
            return category ? '[' + category + '] ' : '';
        },
        title: function title() {
            var category = this.element.category;
            if (category && category.type === 'table') {
                return this.category + '表格元素';
            }

            return this.category + '矢量图形';
        }
    }
};
module.exports = exports['default'];