'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _editorToolbarText = require('./editor-toolbar-text.html');

var _editorToolbarText2 = _interopRequireDefault(_editorToolbarText);

var _editorToolbarImage = require('./editor-toolbar-image.html');

var _editorToolbarImage2 = _interopRequireDefault(_editorToolbarImage);

var _editorToolbarMask = require('./editor-toolbar-mask.html');

var _editorToolbarMask2 = _interopRequireDefault(_editorToolbarMask);

var _editorToolbarGroup = require('./editor-toolbar-group.html');

var _editorToolbarGroup2 = _interopRequireDefault(_editorToolbarGroup);

var _editorToolbarSelector = require('./editor-toolbar-selector.html');

var _editorToolbarSelector2 = _interopRequireDefault(_editorToolbarSelector);

var _editorToolbarCroper = require('./editor-toolbar-croper.html');

var _editorToolbarCroper2 = _interopRequireDefault(_editorToolbarCroper);

var _editorToolbarMasker = require('./editor-toolbar-masker.html');

var _editorToolbarMasker2 = _interopRequireDefault(_editorToolbarMasker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var commonTools = {
    opacity: '\n        <editor-opacity-picker\n            :value.sync="model.opacity"\n            :change="setOpacity"\n        ></editor-opacity-picker>\n    ',

    copy: '\n        <button class="editor-tooltips editor-toolbar-btn" data-action="clone" aria-label="\u590D\u5236" @click="clone()">\n            <i class="icon-copy"></i>\n        </button>\n    ',

    lock: '\n        <button\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="lock"\n            @click="lock()"\n            aria-label="\u9501\u5B9A">\n            <i class="icon-lock"></i>\n        </button>\n    ',

    unlock: '\n        <button\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="unlock"\n            @click="unlock()"\n            aria-label="\u89E3\u9664\u9501\u5B9A">\n            <i class="icon-unlock"></i>\n        </button>\n    ',

    remove: '\n        <button\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="remove"\n            @click="remove()"\n            aria-label="\u5220\u9664">\n            <i class="icon-remove"></i>\n        </button>\n    ',

    pipe: '\n        <i class="editor-toolbar-pipe"></i>\n    ',

    space: '\n            <i class="editor-toolbar-space"></i>\n        ',

    top: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="top"\n            aria-label="\u7F6E\u9876"\n            @click="setToTop()"\n        ><i class="icon-top"></i></button>\n    ',

    bottom: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="bottom"\n            aria-label="\u7F6E\u5E95"\n            @click="setToBottom()"\n        ><i class="icon-bottom"></i></button>\n    ',

    more: '\n        <editor-toolbar-more>\n            {{content}}\n        </editor-toolbar-more>\n    '
};

var textTools = {
    edit: '\n        <button\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="edit"\n            aria-label="\u7F16\u8F91"\n            @click="showEditor()"\n        ><i class="icon-edit"></i></button>\n    ',

    color: '\n        <editor-color-picker\n            :color="currentSelection.color"\n            :change="setColor"\n        ></editor-color-picker>\n    ',

    fontList: '\n        <editor-select-picker\n            class="editor-toolbar-font"\n            :items.sync="options.fontList"\n            :value="currentSelection.fontFamily + currentSelection.fontStyle + currentSelection.fontWeight"\n            :is-equal="isFontEqual"\n            :change="setFont"\n        ></editor-select-picker>\n        <div class="editor-toolbar-loading"\n            v-show="!model.$loaded"\n        ><i class="fa fa-spin fa-spinner"></i></div>\n    ',

    fontSize: '\n        <editor-combo-picker\n            :items.sync="options.fontSizeList"\n            :value="currentSelection.fontSize"\n            :change="editor.setFontSize"\n        ></editor-combo-picker>\n    ',

    bold: '\n        <button\n            data-action="text-bold"\n            aria-label="\u52A0\u7C97"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:currentSelection.fontWeight==\'700\'}"\n            @click="editor.toggleBold()"\n        ><i class="icon-text-bold"></i></button>\n    ',

    italic: '\n        <button\n            data-action="text-italic"\n            aria-label="\u659C\u4F53"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:currentSelection.fontStyle==\'italic\'}"\n            @click="editor.toggleItalic()"\n        ><i class="icon-text-italic"></i></button>\n    ',

    underline: '\n        <button\n            data-action="text-underline"\n            aria-label="\u4E0B\u5212\u7EBF"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:currentSelection.textDecoration==\'underline\'}"\n            @click="editor.toggleUnderline()"\n        ><i class="icon-text-underline"></i></button>\n    ',

    through: '\n        <button\n            data-action="text-through"\n            aria-label="\u5220\u9664\u7EBF"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:currentSelection.textDecoration==\'line-through\'}"\n            @click="editor.toggleThrough()"\n        ><i class="icon-text-through"></i></button>\n    ',

    writingMode: '\n        <button\n            data-action="text-horizontal-tb"\n            aria-label="\u6587\u5B57\u65B9\u5411"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:model.writingMode==\'vertical-rl\'}"\n            @click="toggleWritingMode"\n            v-if="!inAutoGrowGroup"\n        ><i class="icon-text-horizontal-tb"></i></button>\n    ',

    alignLeft: '\n        <button\n            data-action="text-align-left"\n            aria-label="\u5DE6\u5BF9\u9F50"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:model.textAlign==\'left\'}"\n            @click="set(\'textAlign\', \'left\')"\n        ><i class="icon-text-left"></i></button>\n    ',

    alignCenter: '\n        <button\n            data-action="text-align-center"\n            aria-label="\u6C34\u5E73\u5C45\u4E2D\u5BF9\u9F50"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:model.textAlign==\'center\'}"\n            @click="set(\'textAlign\', \'center\')"\n        ><i class="icon-text-center"></i></button>\n    ',

    alignRight: '\n        <button\n            data-action="text-align-right"\n            aria-label="\u53F3\u5BF9\u9F50"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:model.textAlign==\'right\'}"\n            @click="set(\'textAlign\', \'right\')"\n        ><i class="icon-text-right"></i></button>\n    ',

    verticalTop: '\n        <button\n            data-action="text-vertical-top"\n            aria-label="\u9876\u90E8\u5BF9\u9F50"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:model.verticalAlign==\'top\'}"\n            @click="setVertical(\'top\')"\n        ><i class="icon-text-vertical-top"></i></button>\n    ',

    verticalMiddle: '\n        <button\n            data-action="text-vertical-middle"\n            aria-label="\u5782\u76F4\u5C45\u4E2D\u5BF9\u9F50"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:model.verticalAlign==\'middle\'}"\n            @click="setVertical(\'middle\')"\n        ><i class="icon-text-vertical-middle"></i></button>\n    ',

    verticalBottom: '\n        <button\n            data-action="text-vertical-bottom"\n            aria-label="\u53F3\u5BF9\u9F50"\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            :class="{active:model.verticalAlign==\'bottom\'}"\n            @click="setVertical(\'bottom\')"\n        ><i class="icon-text-vertical-bottom"></i></button>\n    ',

    lineHeight: '\n        <editor-number-picker\n            label="\u884C&emsp;\u9AD8"\n            :value.sync="model.lineHeight"\n            :min="0"\n            :max="10"\n            :step="0.2"\n        ></editor-number-picker>\n    ',

    letterSpacing: '\n        <editor-number-picker\n            label="\u5B57\u95F4\u8DDD"\n            :value.sync="model.letterSpacing"\n            :min="-60"\n            :max="100"\n            :step="1"\n        ></editor-number-picker>\n    '
};

var imageTools = {
    replace: '\n        <editor-image-picker\n            ref=\'imagePicker\'\n            v-if="model.type == \'image\'"\n            :change="replaceImage"\n            :after-select="showLoadingTip"\n        ></editor-image-picker>\n    ',

    crop: '\n        <button\n            v-if="model.type==\'image\'"\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="crop" @click="crop()"\n            aria-label="\u88C1\u526A"\n        ><i class="icon-crop"></i></button>\n    ',

    flipX: '\n        <button\n            class="editor-tooltips\n            editor-toolbar-btn"\n            data-action="flip-x"\n            @click="flip(\'x\')"\n            aria-label="\u6C34\u5E73\u7FFB\u8F6C"\n        ><i class="icon-revert-h"></i></button>\n    ',

    flipY: '\n        <button\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="flip-y"\n            @click="flip(\'y\')"\n            aria-label="\u5782\u76F4\u7FFB\u8F6C"\n        ><i class="icon-revert-v"></i></button>\n    '
};

var maskTools = {
    replace: '\n        <editor-image-picker\n            ref=\'imagePicker\'\n            :change="replaceImage"\n            :after-select="showLoadingTip"\n        ></editor-image-picker>\n    ',

    crop: '\n        <button\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="edit"\n            aria-label="\u7F16\u8F91"\n            @click="showEditor()"\n        ><i class="icon-edit"></i></button>\n    ',

    flipX: imageTools.flipX,

    flipY: imageTools.flipY
};

var groupTools = {

    colors: '\n        <editor-color-picker\n            v-for="(color, key) in defaultElement.colors" :key="key"\n            :color.sync="color"\n            :param="key"\n            :change="setColor"\n        ></editor-color-picker>\n    ',

    flat: '\n        <button\n            v-if="model.canCollapse"\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="unlink"\n            @click="flatGroup()"\n            aria-label="\u62C6\u5206\u7EC4"\n        ><i class="icon-unlink"></i></button>\n    ',

    subToolbar: '\n        <component\n            v-if="!model.lock && subModel && subModel != defaultElement"\n            :template="options.toolbarTemplates && options.toolbarTemplates[subModel.type]"\n            :is="\'editor-toolbar-\' + subModel.type"\n            :options="options"\n            :global="global"\n            :model="subModel"\n            :disable-layer-edit="true"\n        ></component>\n    '
};

var svgTools = {
    colors: '\n        <editor-color-picker\n            v-for="(color, key) in model.colors" :key="key"\n            :color.sync="color"\n            :param="key"\n            :change="setColor"\n        ></editor-color-picker>\n    '
};

var selectorTools = {

    makeGroup: '\n        <button\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="link"\n            @click="createGroup()"\n            aria-label="\u6210\u7EC4"\n        ><i class="icon-link"></i></button>\n    ',

    alignmentTop: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u9876\u5BF9\u9F50"\n            @click="alignment(\'alignmentTop\')"\n        ><i class="icon-alignment-top"></i></button>\n    ',

    alignmentMiddle: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u5782\u76F4\u5C45\u4E2D\u5BF9\u9F50"\n            @click="alignment(\'alignmentMiddle\')"\n        ><i class="icon-alignment-middle"></i></button>\n    ',

    alignmentBottom: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u5E95\u5BF9\u9F50"\n            @click="alignment(\'alignmentBottom\')"\n        ><i class="icon-alignment-bottom"></i></button>\n    ',

    alignmentLeft: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u5DE6\u5BF9\u9F50"\n            @click="alignment(\'alignmentLeft\')"\n        ><i class="icon-alignment-left"></i></button>\n    ',

    alignmentCenter: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u6C34\u5E73\u5C45\u4E2D\u5BF9\u9F50"\n            @click="alignment(\'alignmentCenter\')"\n        ><i class="icon-alignment-center"></i></button>\n    ',

    alignmentRight: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u53F3\u5BF9\u9F50"\n            @click="alignment(\'alignmentRight\')"\n        ><i class="icon-alignment-right"></i></button>\n    ',

    distributionTop: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u9876\u5206\u5E03"\n            @click="alignment(\'distributionTop\')"\n        ><i class="icon-distribution-top"></i></button>\n    ',

    distributionMiddle: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u5782\u76F4\u5C45\u4E2D\u5206\u5E03"\n            @click="alignment(\'distributionMiddle\')"\n        ><i class="icon-distribution-middle"></i></button>\n    ',

    distributionBottom: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u5E95\u5206\u5E03"\n            @click="alignment(\'distributionBottom\')"\n        ><i class="icon-distribution-bottom"></i></button>\n    ',

    distributionLeft: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u5DE6\u5206\u5E03"\n            @click="alignment(\'distributionLeft\')"\n        ><i class="icon-distribution-left"></i></button>\n    ',

    distributionCenter: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u6C34\u5E73\u5C45\u4E2D\u5206\u5E03"\n            @click="alignment(\'distributionCenter\')"\n        ><i class="icon-distribution-center"></i></button>\n    ',

    distributionRight: '\n        <button\n            class="editor-tooltips tip-top editor-toolbar-btn"\n            data-action="link"\n            aria-label="\u53F3\u5206\u5E03"\n            @click="alignment(\'distributionRight\')"\n        ><i class="icon-distribution-right"></i></button>\n    '
};

var croperTools = {
    title: '<span class="editor-toolbar-text">缩放</span>',

    scaler: '<editor-percentage-scaler></editor-percentage-scaler>',

    apply: '\n        <button\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="apply"\n            aria-label="\u5B8C\u6210"\n            @click.stop="applyEdit()"\n        ><i class="icon-success"></i></button>\n    ',

    cancel: '\n        <button\n            class="editor-tooltips editor-toolbar-btn"\n            data-action="cancel"\n            aria-label="\u53D6\u6D88"\n            @click.stop="cancelEdit()"\n        ><i class="icon-times"></i></button>\n    '
};

var maskerTools = {
    apply: croperTools.apply,
    cancel: croperTools.cancel
};

var toolsTpl = {
    commonTools: commonTools,
    imageTools: imageTools,
    maskTools: maskTools,
    svgTools: svgTools,
    textTools: textTools,
    groupTools: groupTools,
    selectorTools: selectorTools,
    croperTools: croperTools,
    maskerTools: maskerTools,
    cutomTools: {}
};

var toolBar = {
    allTools: toolsTpl,
    templates: {},
    compile: function compile(tpl) {
        return tpl.replace(/\$\{([^}]+?)\}/g, function (match, p1) {
            var result = toolsTpl;
            var isResult = p1.split('.').every(function (key) {
                if ((typeof result === 'undefined' ? 'undefined' : _typeof(result)) === 'object' && key in result) {
                    result = result[key];
                    return true;
                } else {
                    return false;
                }
            });

            return isResult ? result : '';
        });
    }
};

toolBar.templates.text = toolBar.compile(_editorToolbarText2.default);
toolBar.templates.image = toolBar.compile(_editorToolbarImage2.default);
toolBar.templates.mask = toolBar.compile(_editorToolbarMask2.default);
toolBar.templates.group = toolBar.compile(_editorToolbarGroup2.default);
toolBar.templates.selector = toolBar.compile(_editorToolbarSelector2.default);
toolBar.templates.croper = toolBar.compile(_editorToolbarCroper2.default);
toolBar.templates.masker = toolBar.compile(_editorToolbarMasker2.default);

exports.default = toolBar;
module.exports = exports['default'];