'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _assign2 = require('lodash/assign');

var _assign3 = _interopRequireDefault(_assign2);

var _vueInherit = require('../utils/vue-inherit');

var _vueInherit2 = _interopRequireDefault(_vueInherit);

var _editorToolbar = require('./editor-toolbar');

var _editorToolbar2 = _interopRequireDefault(_editorToolbar);

var _editorToolbarConfig = require('./editor-toolbar-config.js');

var _editorToolbarConfig2 = _interopRequireDefault(_editorToolbarConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _vueInherit2.default)(_editorToolbar2.default, {
    template: _editorToolbarConfig2.default.templates.group,
    data: function data() {
        return {};
    },

    computed: {
        defaultElement: function defaultElement() {
            var element = this.model.elements[0];

            if (element && element.type === 'svg') {
                return element;
            }

            return null;
        }
    },
    methods: {
        flatGroup: function flatGroup() {
            this.editor.flatGroup();
        },
        setColor: function setColor(val, index) {
            if (this.defaultElement.colors[index] !== val) {
                var colors = null;
                if (Array.isArray(this.defaultElement.colors)) {
                    colors = [].concat(this.defaultElement.colors);
                } else {
                    colors = (0, _assign3.default)({}, this.defaultElement.colors);
                }
                colors[index] = val;
                this.set('colors', colors);
                this.defaultElement.colors = colors;
            }
        }
    },

    created: function created() {}
});
module.exports = exports['default'];