'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _vueInherit = require('../utils/vue-inherit');

var _vueInherit2 = _interopRequireDefault(_vueInherit);

var _editorToolbar = require('./editor-toolbar');

var _editorToolbar2 = _interopRequireDefault(_editorToolbar);

var _editorToolbarConfig = require('./editor-toolbar-config');

var _editorToolbarConfig2 = _interopRequireDefault(_editorToolbarConfig);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = (0, _vueInherit2.default)(_editorToolbar2.default, {
    template: _editorToolbarConfig2.default.templates.text,
    data: function data() {
        return {
            neededSpace: 255
        };
    },

    computed: {
        inAutoGrowGroup: function inAutoGrowGroup() {
            var currentElement = this.editor.currentElement;


            if (currentElement.type !== 'group') {
                return false;
            }

            return currentElement.autoGrow;
        },
        currentSelection: function currentSelection() {
            return this.editor.currentSelection || this.model;
        }
    },

    methods: {
        isFontEqual: function isFontEqual() {
            var font = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
            var name = font.name,
                family = font.family;

            var modelFontName = this.currentSelection.fontFamily;

            return modelFontName === name || modelFontName === family;
        },
        setFont: function setFont(font) {
            if (!font) return;

            this.editor.setFontFamily(font.family || font.name);
        },
        setColor: function setColor(color) {
            this.currentSelection.color !== color && this.editor.setColor(color);
        },
        setVertical: function setVertical(dir) {
            this.set('verticalAlign', dir);
        },
        setWritingMode: function setWritingMode(newMode) {
            this.set('writingMode', newMode);
        },
        toggleWritingMode: function toggleWritingMode() {
            this.setWritingMode(this.model.writingMode === 'horizontal-tb' ? 'vertical-rl' : 'horizontal-tb');
        }
    }
});
module.exports = exports['default'];