'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

function loadImage(url) {
    var loaded = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};

    var image = new Image();
    image.crossOrigin = 'Anonymous';
    image.onload = function () {
        loaded(image);
    };
    image.src = url;
    return image;
};

function createImage(file) {
    var success = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function () {};

    var reader = new FileReader();

    if (file.type.match(/image\/(jpeg|gif|png)/)) {
        reader.onload = function (e) {
            loadImage(e.target.result, success);
        };
        reader.readAsDataURL(file);
    } else {}
}

function DropFile(elem, events) {
    var dragover = function dragover(e) {
        (events.dragover || function () {}).call(elem, e);
    };

    var drop = function drop(e) {
        e.preventDefault();
        var files = e.dataTransfer.files;
        for (var i = 0, len = files.length; i < len; i++) {
            createImage(files[i], events.drop || function () {});
        }
    };

    this.destory = function () {
        elem = this.elem;
        elem.removeEventListener('dragover', dragover);
        elem.removeEventListener('drop', drop);
    };

    this.init = function (elem, events) {
        this.elem = elem;
        this.events = events;

        elem.addEventListener('dragover', dragover, false);
        elem.addEventListener('drop', drop, false);
    };

    this.init(elem);
}

exports.default = DropFile;
module.exports = exports['default'];