'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.models = undefined;
exports.useElementModel = useElementModel;

var _elementBaseModel = require('../models/element-base-model');

var _elementBaseModel2 = _interopRequireDefault(_elementBaseModel);

var _elementTextModel = require('../models/element-text-model');

var _elementTextModel2 = _interopRequireDefault(_elementTextModel);

var _elementMaskModel = require('../models/element-mask-model');

var _elementMaskModel2 = _interopRequireDefault(_elementMaskModel);

var _elementImageModel = require('../models/element-image-model');

var _elementImageModel2 = _interopRequireDefault(_elementImageModel);

var _elementGroupModel = require('../models/element-group-model');

var _elementGroupModel2 = _interopRequireDefault(_elementGroupModel);

var _elementSvgModel = require('../models/element-svg-model');

var _elementSvgModel2 = _interopRequireDefault(_elementSvgModel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var models = exports.models = {
    'text': _elementTextModel2.default,
    'mask': _elementMaskModel2.default,
    'image': _elementImageModel2.default,
    'group': _elementGroupModel2.default,
    'svg': _elementSvgModel2.default
};

function useElementModel(data) {
    if (models[data.type]) {
        return new models[data.type](data);
    } else {
        return new _elementBaseModel2.default(data);
    }
};