'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _isEqual2 = require('lodash/isEqual');

var _isEqual3 = _interopRequireDefault(_isEqual2);

var _assign2 = require('lodash/assign');

var _assign3 = _interopRequireDefault(_assign2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _bluebird = require('bluebird');

var _effect = require('./effect');

var _effect2 = _interopRequireDefault(_effect);

var _defaultModel = require('./data/default-model');

var _defaultModel2 = _interopRequireDefault(_defaultModel);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var ImageEffectModel = function () {
    function ImageEffectModel(imageEffect) {
        _classCallCheck(this, ImageEffectModel);

        this.effectMaker = new _effect2.default(imageEffect._img, imageEffect._imgZoom);
        this.object = this.effectMaker.group;
    }

    _createClass(ImageEffectModel, [{
        key: 'useData',
        value: function useData(effect) {
            var _this = this;

            (0, _assign3.default)(this, Object.assign((0, _defaultModel2.default)(), effect));

            if (!effect.enable || (0, _isEqual3.default)(effect, ImageEffectModel.default)) {
                return _bluebird.Promise.resolve();
            }

            if (effect._offsetX || effect._offsetY) {
                this.effectMaker.setOffset({
                    x: effect._offsetX,
                    y: effect._offsetY
                });
            }

            var execOrder = ['mask', 'filling', 'stroke', 'shadow', 'expand'];
            var handlers = execOrder.reduce(function (handlers, key) {
                if (effect[key].enable) {
                    var handler = function handler() {
                        return _this.handler[key](effect[key]);
                    };

                    if (key === 'mask') {
                        handlers.mask = handler;
                    } else {
                        handlers.queue.push(handler);
                    }
                }

                return handlers;
            }, {
                mask: function mask() {
                    return _bluebird.Promise.resolve();
                },
                queue: []
            });

            return handlers.mask().then(function () {
                return _bluebird.Promise.all(handlers.queue.map(function (handle) {
                    return handle();
                }));
            });
        }
    }, {
        key: 'handler',
        get: function get() {
            var _this2 = this;

            return {
                shadow: function shadow(val) {
                    return _this2.effectMaker.setShadow(val);
                },
                stroke: function stroke(val) {
                    return _this2.effectMaker.setStroke(val);
                },
                filling: function filling(val) {
                    var type = val.type,
                        color = val.color,
                        gradient = val.gradient,
                        imageContent = val.imageContent;

                    var options = {
                        type: type
                    };

                    switch (type) {
                        case 'color':
                            options.color = color;
                            break;
                        case 'gradient':
                            (0, _assign3.default)(options, {
                                gradientType: gradient.type,
                                angle: gradient.angle,
                                colorStops: gradient.stops.reduce(function (ret, _ref) {
                                    var offset = _ref.offset,
                                        color = _ref.color;

                                    ret[offset] = color;

                                    return ret;
                                }, {})
                            });
                            break;
                        case 'image':
                            (0, _assign3.default)(options, imageContent);
                    }

                    return _this2.effectMaker.setFilling(options);
                },
                mask: function mask(val) {
                    return _this2.effectMaker.setMask(val);
                },
                expand: function expand(val) {
                    return _this2.effectMaker.setExpand(val);
                }
            };
        }
    }]);

    return ImageEffectModel;
}();

ImageEffectModel.effects = ['offset', 'shadow', 'stroke', 'filling', 'mask', 'expand'];
ImageEffectModel.maskTypes = _effect2.default.maskTypes;
ImageEffectModel.default = (0, _defaultModel2.default)();
exports.default = ImageEffectModel;
module.exports = exports['default'];