'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.clone = clone;
exports.cloneAsRect = cloneAsRect;
exports.cloneAsImage = cloneAsImage;

var _fabric = require('fabric');

function clone(obj) {
    return new Promise(function (resolve) {
        if (obj.type === 'image') {
            resolve(new _fabric.fabric.Image(obj.getElement(), {
                scaleX: obj.scaleX,
                scaleY: obj.scaleY,
                left: obj.left,
                top: obj.top
            }));
        } else {
            obj.clone(resolve);
        }
    });
}

function cloneAsRect(obj) {
    return Promise.resolve(new _fabric.fabric.Rect({
        width: obj.getScaledWidth(),
        height: obj.getScaledHeight(),
        left: obj.left,
        top: obj.top
    }));
}

function cloneAsImage(obj) {
    return !obj || obj.type === 'image' ? Promise.resolve(obj) : new Promise(function (resolve) {
        var canvas = new _fabric.fabric.StaticCanvas(null, {
            width: obj.width,
            height: obj.height
        });
        canvas.add(obj);
        canvas.renderAll();

        resolve(new _fabric.fabric.Image(canvas.getElement()));
    });
}