'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = createAlphaPattern;

var _fabric = require('fabric');

var _clone = require('../clone');

var _createMaskedObject = require('./create-masked-object');

var _createMaskedObject2 = _interopRequireDefault(_createMaskedObject);

var _createImage = require('./create-image');

var _createImage2 = _interopRequireDefault(_createImage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createAlphaPattern(obj) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    return (0, _createImage2.default)(options.image).then(function (image) {
        var scaleX = options.width / image.width || 1;
        var scaleY = options.height / image.height || 1;
        var pattern = new _fabric.fabric.Pattern({
            source: image.getElement(),
            repeat: options.repeat || 'no-repeat',
            offsetX: options.offsetX || 0,
            offsetY: options.offsetY || 0,
            patternTransform: options.patternTransform || [scaleX * options.zoom, 0, 0, scaleY * options.zoom, 0, 0]
        });
        var filling = new _fabric.fabric.Rect({
            width: obj.width,
            height: obj.height,
            fill: pattern
        });

        return (0, _clone.clone)(obj).then(function (cloned) {
            var filled = (0, _createMaskedObject2.default)(filling, cloned);

            return new _fabric.fabric.Image(filled, {
                left: obj.left,
                top: obj.top
            });
        });
    });
}
module.exports = exports['default'];