'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = createImage;

var _fabric = require('fabric');

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _utils = require('../../../utils');

var _utils2 = _interopRequireDefault(_utils);

var _clone = require('../clone');

var _loadSvg = require('../load-svg');

var _loadSvg2 = _interopRequireDefault(_loadSvg);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createImage(object) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    return _bluebird2.default.try(function () {
        if (object instanceof HTMLElement) {
            return _bluebird2.default.resolve(new _fabric.fabric.Image(object, options));
        }

        if (object instanceof _fabric.fabric.Image) {
            return _bluebird2.default.resolve(object);
        }

        if (typeof object === 'string') {
            return (/svg/.test(object) ? (0, _loadSvg2.default)(object).then(_clone.cloneAsImage) : _utils2.default.loadImage(object, true).then(function (img) {
                    return new _fabric.fabric.Image(img, options);
                })
            );
        }

        return (0, _clone.cloneAsImage)(object);
    });
}
module.exports = exports['default'];