'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = createMaskedObject;

var _fabric = require('fabric');

function createMaskedObject(image, mask) {
    var canvas = new _fabric.fabric.StaticCanvas(null, {
        width: image.width,
        height: image.height
    });

    image.set('globalCompositeOperation', 'source-in');
    canvas.add(mask, image);

    mask.center();
    image.center();
    canvas.renderAll();

    return canvas.getElement();
}
module.exports = exports['default'];