'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _isNumber2 = require('lodash/isNumber');

var _isNumber3 = _interopRequireDefault(_isNumber2);

exports.default = createStroke;

var _fabric = require('fabric');

var _clone = require('../clone');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createStroke(object) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var strokeOptions = {
        stroke: options.color || '#ffffff',
        strokeWidth: (0, _isNumber3.default)(options.width) ? options.width : 50
    };

    var canvas = document.createElement('canvas');
    var ctx = canvas.getContext('2d');

    return (0, _clone.clone)(object).then(function (cloned) {
        var strokeWidth = strokeOptions.strokeWidth;
        var imageCanvas = new _fabric.fabric.StaticCanvas(null, {
            width: cloned.width + strokeWidth * 2,
            height: cloned.height + strokeWidth * 2
        });
        imageCanvas.add(cloned);
        cloned.center();
        imageCanvas.renderAll();

        var image = imageCanvas.getElement();
        canvas.width = image.width;
        canvas.height = image.height;
        for (var i = 0; i < 360; i++) {
            ctx.drawImage(image, Math.sin(i) * strokeWidth, Math.cos(i) * strokeWidth);
        }

        ctx.globalCompositeOperation = 'source-in';
        ctx.fillStyle = strokeOptions.stroke;
        ctx.fillRect(0, 0, canvas.width, canvas.height);

        var stroked = new _fabric.fabric.Image(canvas, {
            left: object.left - strokeWidth,
            top: object.top - strokeWidth
        });

        return stroked;
    });
}
module.exports = exports['default'];