"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = getGradientPoint;
function getGradientPoint(inputAngle, length) {
    var eps = Math.pow(2, -52);
    var angle = inputAngle % 360;
    var startPoint = pointOfAngle(degreesToRadians(180 - angle));
    var endPoint = pointOfAngle(degreesToRadians(360 - angle));

    if (startPoint.x <= 0 || Math.abs(startPoint.x) <= eps) startPoint.x = 0;

    if (startPoint.y <= 0 || Math.abs(startPoint.y) <= eps) startPoint.y = 0;

    if (endPoint.x <= 0 || Math.abs(endPoint.x) <= eps) endPoint.x = 0;

    if (endPoint.y <= 0 || Math.abs(endPoint.y) <= eps) endPoint.y = 0;

    return {
        x1: startPoint.x * length,
        x2: endPoint.x * length,
        y1: startPoint.y * length,
        y2: endPoint.y * length
    };
}

function pointOfAngle(a) {
    return {
        x: Math.cos(a),
        y: Math.sin(a)
    };
}

function degreesToRadians(d) {
    return d * Math.PI / 180;
}
module.exports = exports["default"];