'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var slice = Array.prototype.slice;

var pickFile = function pickFile() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        _ref$multiple = _ref.multiple,
        multiple = _ref$multiple === undefined ? false : _ref$multiple,
        _ref$accept = _ref.accept,
        accept = _ref$accept === undefined ? '*/*' : _ref$accept;

    var doc = document;
    var body = doc.body || doc.documentElement;

    return new _bluebird2.default(function (resolve) {
        var input = doc.createElement('input');
        var clearInput = function clearInput() {
            body.removeEventListener('mousedown', clearInput, false);

            body.removeChild(input);

            input.onchange = null;
        };

        input.setAttribute('type', 'file');
        input.setAttribute('accept', accept);
        input.setAttribute('multiple', multiple);
        input.style.cssText = 'position:absolute;top:-199px;height:0;opacity:0';

        input.onchange = function () {
            var files = slice.call(input.files);
            if (!files[0]) {
                return;
            }

            resolve(multiple ? files : files[0]);
        };

        body.appendChild(input);

        input.click();

        body.addEventListener('mousedown', clearInput, false);
    });
};

exports.default = pickFile;
module.exports = exports['default'];