'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var readFile = function readFile(file) {
    var dataType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'DataURL';

    return new _bluebird2.default(function (resolve, reject) {
        var reader = new FileReader();
        var fnName = 'readAs' + dataType;

        if (!reader[fnName]) {
            throw new Error('File read error, dataType not support');
        }

        reader.onerror = function () {
            reject(new Error('File read error'));
        };

        reader.onload = function () {
            resolve(reader.result);
        };

        reader[fnName](file);
    });
};

exports.default = readFile;
module.exports = exports['default'];