'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _pica = require('pica/dist/pica');

var _pica2 = _interopRequireDefault(_pica);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var resizeImage = function resizeImage(src, dist) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    var throwError = !!options.throwError;
    var timeout = +options.timeout || 5000;

    return _bluebird2.default.try(function () {
        if (!resizeImage.resizer) {
            resizeImage.resizer = new _pica2.default({
                features: ['js', 'wasm', 'ww']
            });
        }

        return resizeImage.resizer;
    }).then(function (resizer) {
        return resizer.resize(src, dist, options);
    }).timeout(timeout, 'Image resize timeout by pica').catch(function (err) {
        console.info(err.message, err);

        if (throwError) {
            throw err;
        }

        return src;
    });
};

exports.default = resizeImage;
module.exports = exports['default'];