'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _command = require('./command');

var _command2 = _interopRequireDefault(_command);

var _selection = require('./selection');

var _selection2 = _interopRequireDefault(_selection);

var _serialize = require('./utils/serialize');

var _serialize2 = _interopRequireDefault(_serialize);

var _paste = require('./utils/paste');

var _eventEmitter = require('../event-emitter');

var _eventEmitter2 = _interopRequireDefault(_eventEmitter);

var _config = require('./config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MutationObserver = window.MutationObserver || window.WebKitMutationObserver || window.MozMutationObserver;

var RichText = function (_EventEmitter) {
    _inherits(RichText, _EventEmitter);

    function RichText(textElem, options) {
        _classCallCheck(this, RichText);

        var _this = _possibleConstructorReturn(this, (RichText.__proto__ || Object.getPrototypeOf(RichText)).call(this));

        _this.$textElem = (0, _jquery2.default)(textElem);
        _this.setConfig(options);
        _this._init();
        return _this;
    }

    _createClass(RichText, [{
        key: '_init',
        value: function _init() {
            this.selection = new _selection2.default(this.$textElem);
            this.cmd = new _command2.default(this.selection);

            this.clear();
            this._bindSaveRange();
            this._bindPaste();
            this._changed();
            this._bindClear();
        }
    }, {
        key: '_bindSaveRange',
        value: function _bindSaveRange() {
            var $textElem = this.$textElem;
            var selection = this.selection;

            var saveRange = function saveRange() {
                return selection.saveRange();
            };

            $textElem.on('keyup.richText', saveRange);
            $textElem.on('mousedown.richText', function () {
                $textElem.on('mouseleave.richText', saveRange);
            });

            $textElem.on('mouseup.richText', function () {
                setTimeout(saveRange, 50);

                $textElem.off('mouseleave.richText', saveRange);
            });
        }
    }, {
        key: '_bindPaste',
        value: function _bindPaste() {
            var _this2 = this;

            var selection = this.selection;
            var cmd = this.cmd;
            var $textElem = this.$textElem;

            $textElem.on('paste.richText', function (e) {
                if ($textElem.prop('contenteditable') !== 'true') return;

                var pasteText = (0, _paste.getPasteText)(e);
                var $selectionElem = selection.getSelectionContainerElem();
                if ($selectionElem) {
                    cmd.do('insertHTML', pasteText);
                    _this2._createPlaceholderDOM();
                }

                e.stopPropagation();
                e.preventDefault();
            }).on('copy.richText cut.richText', function (e) {
                if ($textElem.prop('contenteditable') !== 'true') return;

                e.stopPropagation();
            });
        }
    }, {
        key: '_createPlaceholderDOM',
        value: function _createPlaceholderDOM(isFirst) {
            var $textElem = this.$textElem;
            var children = $textElem.children().not('br');
            var text = $textElem.text().replace(/\u200b/g, '');

            if (!text && children[0] && children[0].nodeName !== 'P') {
                var $brs = $textElem.find('br');

                this._insertWrap($brs.length === 2 ? '<br>&#8203;' : '', isFirst);
            } else if (!children.length) {
                this._insertWrap(text, isFirst);
            }
        }
    }, {
        key: '_insertWrap',
        value: function _insertWrap() {
            var html = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
            var isFirst = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
            var defaultStyle = this.config.defaultStyle;
            var $textElem = this.$textElem,
                selection = this.selection;

            var defaultDOM = '<p ' + _config.CUSTOMIZE_MARK + ' style="' + defaultStyle + '">' + (html || '&#8203;') + '</p>';
            $textElem.html('');

            if (isFirst === false) {
                $textElem.focus();

                this.cmd.do('insertHTML', defaultDOM);
            } else {
                defaultDOM = (0, _jquery2.default)(defaultDOM)[0];
                $textElem.append(defaultDOM);
                selection.createRangeByElem(defaultDOM, true);
            }

            selection.collapse(false);
        }
    }, {
        key: '_bindClear',
        value: function _bindClear() {
            var _this3 = this;

            var $textElem = this.$textElem;
            var pattren = new RegExp('^ *<p ' + _config.CUSTOMIZE_MARK + '[^<>]*>(\u200B|<br>)?</p> *$');

            $textElem.on('keyup', function () {
                return _this3._createPlaceholderDOM();
            }).on('keydown', function (e) {
                if (e.keyCode !== 8) return;
                var html = $textElem.html();

                if (pattren.test(html)) {
                    e.preventDefault();
                }
            });

            this._createPlaceholderDOM(true);
        }
    }, {
        key: '_changed',
        value: function _changed() {
            var _this4 = this;

            var timer = null;
            var target = this.$textElem[0];
            var config = {
                attributes: true,
                childList: true,
                subtree: true,
                characterData: true
            };

            var observer = target.__richeTextObserver__ = new MutationObserver(function () {
                _this4.emit('changeImmediate', _this4.$textElem[0]);
                _this4.emit('_changeImmediate', _this4.$textElem[0]);

                clearTimeout(timer);

                timer = setTimeout(function () {
                    var curHtml = _this4.$textElem.html();
                    if (curHtml !== _this4._prevHtml) {
                        _this4.emit('change', _this4.$textElem[0]);
                        _this4.emit('_change', _this4.$textElem[0]);
                        _this4._prevHtml = curHtml;
                    }
                }, 100);
            });

            observer.observe(target, config);
        }
    }, {
        key: 'setConfig',
        value: function setConfig(options) {
            if (!options) return;
            var config = this.config || {
                defaultStyle: ''
            };

            Object.assign(config, options);

            var defaultStyle = config.defaultStyle;


            config.defaultStyle = typeof defaultStyle === 'string' ? defaultStyle : _serialize2.default._getStyleString(defaultStyle);

            this.config = config;
        }
    }, {
        key: 'fromJSON',
        value: function fromJSON(html) {
            html = html || this.$textElem.html();

            for (var _len = arguments.length, rest = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
                rest[_key - 1] = arguments[_key];
            }

            var result = _serialize2.default.fromJSON.apply(_serialize2.default, [html].concat(rest));
            return result;
        }
    }, {
        key: 'fromHTML',
        value: function fromHTML() {
            return _serialize2.default.fromHTML.apply(_serialize2.default, arguments);
        }
    }, {
        key: 'clear',
        value: function clear() {
            var $textElem = this.$textElem;
            $textElem[0].__richeTextObserver__ && $textElem[0].__richeTextObserver__.disconnect();
            $textElem.off('keyup.richText');
            $textElem.off('mousedown.richText');
            $textElem.off('mouseleave.richText');
            $textElem.off('mouseup.richText');
            $textElem.off('paste.richText');
            $textElem.off('copy.richText');
            $textElem.off('cut.richText');
        }
    }]);

    return RichText;
}(_eventEmitter2.default);

exports.default = RichText;

Object.keys(_serialize2.default).forEach(function (key) {
    var fn = _serialize2.default[key];
    RichText[key] = fn;
});
module.exports = exports['default'];