'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _eventEmitter = require('../event-emitter');

var _eventEmitter2 = _interopRequireDefault(_eventEmitter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Selection = function (_EventEmitter) {
    _inherits(Selection, _EventEmitter);

    function Selection(textElem) {
        _classCallCheck(this, Selection);

        var _this = _possibleConstructorReturn(this, (Selection.__proto__ || Object.getPrototypeOf(Selection)).call(this));

        _this.$textElem = (0, _jquery2.default)(textElem);
        _this._currentRange = null;
        return _this;
    }

    _createClass(Selection, [{
        key: 'getRange',
        value: function getRange() {
            return this._currentRange;
        }
    }, {
        key: 'saveRange',
        value: function saveRange(_range) {
            if (_range) {
                this._currentRange = _range;
                return;
            }

            var $textElem = this.$textElem;
            var selection = window.getSelection();

            if (selection.rangeCount === 0) return;

            var range = selection.getRangeAt(0);

            var containerElem = this.getSelectionContainerElem(range);

            if (!containerElem) return;

            if (_jquery2.default.contains($textElem[0], containerElem) || $textElem[0] === containerElem) {
                this._currentRange = range;
            }

            this._changed();
        }
    }, {
        key: 'collapse',
        value: function collapse() {
            var toStart = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

            if (this._currentRange) {
                this._currentRange.collapse(toStart);
                this.restoreSelection();
            }
        }
    }, {
        key: 'restoreSelection',
        value: function restoreSelection() {
            var selection = window.getSelection();
            selection.removeAllRanges();
            selection.addRange(this._currentRange);
            this._changed();
        }
    }, {
        key: 'isSelectionEmpty',
        value: function isSelectionEmpty() {
            var range = this._currentRange;

            return range && range.startContainer && range.startContainer === range.endContainer && range.startOffset === range.endOffset;
        }
    }, {
        key: 'createEmptyRange',
        value: function createEmptyRange(cmd) {
            var range = this.getRange();

            if (!range || !this.isSelectionEmpty()) {
                return;
            }

            try {
                var elem = (0, _jquery2.default)('<span>&#8203;</span>')[0];
                cmd.do('insertElem', elem);
                this.createRangeByElem(elem, true);
            } catch (e) {
                console.error(e);
            }
        }
    }, {
        key: 'getSelectionStartElem',
        value: function getSelectionStartElem() {
            var range = this._currentRange;
            if (range) {
                var elem = range.startContainer;
                return elem.nodeType === 1 ? elem : elem.parentNode;
            }
        }
    }, {
        key: 'getSelectionContainerElem',
        value: function getSelectionContainerElem(range) {
            range = range || this._currentRange;
            if (range) {
                var elem = range.commonAncestorContainer;
                return elem.nodeType === 1 ? elem : elem.parentNode;
            }
        }
    }, {
        key: 'cloneContents',
        value: function cloneContents() {
            var range = this._currentRange;
            if (range) {
                var result = range.cloneContents();
                return result;
            }
        }
    }, {
        key: 'createRangeByElem',
        value: function createRangeByElem(elem, isContent) {
            elem = elem || this.$textElem[0];
            if (!elem) {
                return;
            }

            var range = document.createRange();

            if (isContent) {
                range.selectNodeContents(elem);
            } else {
                range.selectNode(elem);
            }

            this._currentRange = range;
            this.restoreSelection();
        }
    }, {
        key: 'createRangeByElems',
        value: function createRangeByElems(startElem, endElem) {
            var startOffset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
            var endOffset = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

            var range = document.createRange();

            if (!startElem || !endElem) throw new Error('startElem endElem is required');

            startOffset === false ? range.setStartBefore(startElem) : range.setStart(startElem, startOffset);
            endOffset === false ? range.setEndAfter(endElem) : range.setEnd(endElem, endOffset);

            this._currentRange = range;
            this.restoreSelection();
        }
    }, {
        key: 'clearRange',
        value: function clearRange() {
            if (!this._currentRange) return;
            var selection = window.getSelection();
            selection.removeRange(this._currentRange);
            this._currentRange = null;
        }
    }, {
        key: '_changed',
        value: function _changed() {
            var _this2 = this;

            clearTimeout(this._timer);
            this.timer = setTimeout(function () {
                var range = _this2._currentRange;

                var rangeInfo = [range.startContainer, range.endContainer, range.startOffset, range.endOffset, range.toString()];

                var diff = function diff() {
                    return rangeInfo.some(function (item, i) {
                        return item !== _this2._prevRangeInfo[i];
                    });
                };

                if (!_this2._prevRangeInfo || diff()) {
                    _this2.emit('change', _this2._currentRange);
                    _this2.emit('_change', _this2._currentRange);

                    _this2._prevRangeInfo = rangeInfo;
                }
            }, 100);
        }
    }]);

    return Selection;
}(_eventEmitter2.default);

exports.default = Selection;
;
module.exports = exports['default'];