'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var snapshotRules = exports.snapshotRules = [{
    match: function match(node) {
        return !!node.layouts;
    },
    toRecord: function toRecord(node) {
        return {
            chunks: [_extends({}, node, { layouts: undefined })],
            children: node.layouts
        };
    },
    fromRecord: function fromRecord(_ref) {
        var chunks = _ref.chunks,
            children = _ref.children;
        return _extends({}, chunks[0], { layouts: children });
    }
}, {
    match: function match(node) {
        return !!node.elements;
    },
    toRecord: function toRecord(node) {
        return {
            chunks: [_extends({}, node, { elements: undefined })],
            children: node.elements
        };
    },
    fromRecord: function fromRecord(_ref2) {
        var chunks = _ref2.chunks,
            children = _ref2.children;
        return _extends({}, chunks[0], { elements: children });
    }
}, {
    match: function match(node) {
        return node.type === 'image';
    },
    toRecord: function toRecord(node) {
        return {
            chunks: [_extends({}, node, { url: undefined, effectImage: undefined }), node.url, node.effectImage],
            children: null
        };
    },
    fromRecord: function fromRecord(_ref3) {
        var chunks = _ref3.chunks;
        return _extends({}, chunks[0], { url: chunks[1], effectImage: chunks[2] });
    }
}, {
    match: function match(node) {
        return node.type === 'mask';
    },
    toRecord: function toRecord(node) {
        return {
            chunks: [_extends({}, node, { url: undefined, mask: undefined }), node.url, node.mask],
            children: null
        };
    },
    fromRecord: function fromRecord(_ref4) {
        var chunks = _ref4.chunks;
        return _extends({}, chunks[0], { url: chunks[1], mask: chunks[2] });
    }
}];