'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.default = {
    parse: function parse() {
        var version = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '0.0.0';

        var versions = String(version).split('.');

        while (versions.length < 3) {
            versions.push('0');
        }

        return new function Version(arr) {
            var _this = this;

            ['major', 'minor', 'patch'].forEach(function (key, i) {
                _this[key] = parseInt(arr[i], 10);
            });
            this._string = version;
            this._version = versions;

            this.number = versions.reduce(function (previous, current) {
                previous += ('000' + current).substr(-3, 3);
                return parseInt(previous, 10);
            });
        }(versions);
    }
};
module.exports = exports['default'];