'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

require('@zsk526/jquery-minicolors');

var _editorColorHistory = require('./editor-color-history.html');

var _editorColorHistory2 = _interopRequireDefault(_editorColorHistory);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var historyDatas = {
    '__default__': ['#000000', '#a71717', '#e64a19', '#fdd835', '#f29018', '#e1c3ff', '#0069d5', '#9d29ff']
};

exports.default = {
    template: _editorColorHistory2.default,
    props: ['tage', 'len', 'setColor'],
    data: function data() {
        var tage = this.tage || new Date().getTime();

        return historyDatas[tage] || (historyDatas[tage] = { histories: [].concat(historyDatas.__default__) });
    },

    methods: {
        add: function add(color) {
            color = color.toLowerCase();
            var isSame = this.histories.some(function (item) {
                if (color === item) {
                    return true;
                }
            });
            if (!isSame) {
                this.histories.unshift(color);
            }
            if (this.histories.length > this.len) {
                this.histories.pop();
            }
        },
        remove: function remove(color) {
            this.histories.pop(color);
        },
        get: function get(i) {
            if (this.setColor) {
                this.setColor(this.histories[i], true);
            }
        }
    },

    events: {
        'color.history.add': function colorHistoryAdd(color) {
            if (color) {
                this.add(color);
            }
        }
    }
};
module.exports = exports['default'];