'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _utils = require('../utils/utils');

var _utils2 = _interopRequireDefault(_utils);

var _editorComboPicker = require('./editor-combo-picker.html');

var _editorComboPicker2 = _interopRequireDefault(_editorComboPicker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    template: _editorComboPicker2.default,
    props: ['change', 'value', 'items'],
    data: function data() {
        return {
            active: false,
            currVal: null,
            listMaxHeight: ''
        };
    },

    methods: {
        toggleActive: function toggleActive() {
            this.active = !this.active;
            this.listMaxHeight = '';

            if (this.active) {
                var el = (0, _jquery2.default)(this.$el);

                this.$nextTick(function () {
                    el.find('input').focus().select();
                    this.listMaxHeight = this.getListMaxHeight();

                    this.$nextTick(this.scrollToCurrent);
                });
            }
        },
        set: function set(val) {
            var self = this;

            if (val === undefined) {
                val = this.currVal;
            }

            if (!this.change) {
                this.value = val;
            } else {
                this.change(val);
            }

            setTimeout(function () {
                self.active = false;
            }, 0);
        },
        initOutClick: function initOutClick() {
            var self = this;
            var offOutClick = _utils2.default.addOutClick({
                element: this.$el,
                callback: function callback() {
                    self.active = false;
                }
            });

            this.$on('destroy', offOutClick);
        },
        getListMaxHeight: function getListMaxHeight() {
            var elementRect = this.$refs.list.getBoundingClientRect();
            var offset = document.documentElement.offsetHeight - elementRect.bottom;
            if (offset < 20) {
                return elementRect.height + offset - 20 + 'px';
            }
            return '';
        },
        scrollToCurrent: function scrollToCurrent() {
            var list = this.$refs.list;
            var currentEle = (0, _jquery2.default)(list).find('li.current')[0];
            if (currentEle) {
                currentEle.offsetParent.scrollTop = currentEle.offsetTop;
            }
        }
    },
    mounted: function mounted() {
        this.currVal = this.value;

        this.$watch('value', function () {
            this.currVal = this.value;
        });

        this.initOutClick();
    },
    beforeDestroy: function beforeDestroy() {
        this.$emit('destroy');
    }
};
module.exports = exports['default'];