'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slice2 = require('lodash/slice');

var _slice3 = _interopRequireDefault(_slice2);

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _editorFilePicker = require('./editor-file-picker.html');

var _editorFilePicker2 = _interopRequireDefault(_editorFilePicker);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = {
    template: _editorFilePicker2.default,
    props: ['change', 'afterSelect', 'accept', 'multiple', 'title'],
    data: function data() {
        return {
            defaults: {
                accept: 'image/png,image/jpeg,image/gif',
                title: '选择文件'
            }
        };
    },

    computed: {
        input: function input() {
            return this.$refs.input;
        }
    },
    methods: {
        onChange: function onChange(e) {
            var inp = e.target;
            var files = (0, _slice3.default)(inp.files);

            this.afterSelect && this.afterSelect(inp);

            var ret = files;
            if (!this.multiple) {
                ret = files[0] || null;
            }

            this.change(ret);

            this.$nextTick(function () {
                inp.value = '';
            });
        },
        showPicker: function showPicker(accept) {
            var inp = (0, _jquery2.default)(this.input);

            if (!accept) {
                accept = this.accept || this.defaults.accept;
            }

            inp.click();
        }
    }
};
module.exports = exports['default'];